/*
 * Proyecto: VerificarNifCif
 * Fichero: Form1.prg
 * Descripcin:
 * Autor: Jos Lopez (Pepe)
 * Fecha: 18/02/2024
 */

#include "Xailer.ch"
//#require "hbcurl"
#include "hbcurl.ch"

CLASS TForm1 FROM TForm

   COMPONENT oGlassBtnVerifiNifCif
   COMPONENT oMemo1

   METHOD CreateForm()
   METHOD GlassBtnVerifiNifCifClick( oSender )

ENDCLASS

#include "Form1.xfm"

//------------------------------------------------------------------------------

METHOD GlassBtnVerifiNifCifClick( oSender ) CLASS TForm1

   local oCurl, cUrl, nCodeResponse, cResponse, nPerform
   Local cFileCrtPem, cCrtPass, cFileKeyPem, cKeyPass
   Local cRequestXML, aHeader := Array(3), cSoapAction := "VNifV2"

   curl_global_init()

   Begin Sequence

      ::oMemo1:Value := ""

      cRequestXML := HB_MemoRead("Request.XML")

      cFileCrtPem  := 'Certificado.crt.pem'
      cCrtPass := '123456'
      cFileKeyPem  := 'Certificado.key.pem'
      cKeyPass := '123456'

      cUrl := "https://www1.agenciatributaria.gob.es/wlpl/BURT-JDIT/ws/VNifV2SOAP"

      aHeader[ 1 ] := 'Content-Type: text/xml; charset=utf-8'
      aHeader[ 2 ] := 'SOAPAction: "' + cSoapAction + '"'
      aHeader[ 3 ] := 'Content-length: ' + hb_NToC( Len(cRequestXML) )

      if ! empty( oCurl := curl_easy_init() )

         // specify header
         curl_easy_setopt(oCurl,HB_CURLOPT_HTTPHEADER,aHeader)

         // set endpoint to send the POST to
         curl_easy_setopt(oCurl,HB_CURLOPT_URL,cUrl)

         // do not verify peer with CA cerftificate
         // im my case do not need verification
         curl_easy_setopt(oCurl,HB_CURLOPT_SSL_VERIFYPEER,.F.)
         curl_easy_setopt(oCurl,HB_CURLOPT_SSL_VERIFYHOST,.F.)

         // set response data
         curl_easy_setopt(oCurl,HB_CURLOPT_DOWNLOAD)
         curl_easy_setopt(oCurl,HB_CURLOPT_DL_BUFF_SETUP)

         // specify POST data
            ** do not need this:  curl_easy_setopt(oCurl,HB_CURLOPT_POST, 1)
            ** because command below already did it
         curl_easy_setopt(oCurl,HB_CURLOPT_POSTFIELDS,cRequestXML)

         * put .T. when testing, put .F. in production
         curl_easy_setopt(oCurl,HB_CURLOPT_VERBOSE,.F.)

         curl_easy_setopt( oCurl, HB_CURLOPT_SSLCERT, cFileCrtPem)
         curl_easy_setopt( oCurl, HB_CURLOPT_SSLKEY, cFileKeyPem)
         curl_easy_setopt( oCurl, HB_CURLOPT_SSLCERTPASSWD, cCrtPass)
         curl_easy_setopt( oCurl, HB_CURLOPT_SSLKEYPASSWD, cKeyPass)

         nPerform := curl_easy_perform(oCurl)
         if nPerform == 0
            nCodeResponse := curl_easy_getinfo(oCurl,HB_CURLINFO_RESPONSE_CODE)
            If ! ( nCodeResponse == 200 ) // No hay ningun error
               MsgStop("Error Codigo: "+hb_NToC(nCodeResponse),"Aviso")
            EndIf
            // store response in variable
            cResponse := curl_easy_dl_buff_get(oCurl)
            //LogDebug( cResponse,nCodeResponse )

            ::oMemo1:Value := cResponse

            HB_MemoWrit("Response.xml",cResponse)

         else
            MsgAlert("Error Codigo: "+hb_NToC(nPerform),"Aviso")
         endif

         /* Cleanup session */
         curl_easy_cleanup( oCurl )

      endif

   End Sequence

   curl_global_cleanup()  // Fin de la conexion

RETURN Nil

//------------------------------------------------------------------------------
